unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, RedeemerXML, RedeemerSVGHelpers, Helpers, RedeemerEntities;

type
  TForm1 = class(TForm)
    ComboBox1: TComboBox;
    Label1: TLabel;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    Button1: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    var
      XML: TRedeemerXML;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var
  ImgIndex: Integer;
  TargetIndex: Integer;
  Splitter: TStyleSplitter;
  Filename: string;
  Chars: string;
  s: string;
  Base64: AnsiString;
  ms1, ms2: TMemoryStream;
  OutPath: string;
  emoticons: TStringList;
  OK: Boolean;
  UCS4: Boolean;
begin
  TargetIndex := ComboBox1.ItemIndex;
  Chars := '';
  ms1 := TMemoryStream.Create;
  ms2 := TMemoryStream.Create;
  emoticons := TStringList.Create;
  OutPath := IncludeTrailingPathDelimiter(ExtractFilePath(paramstr(0)) + 'emoticons');
  OK := False;
  UCS4 := RadioButton2.Checked;
  while XML.GoToAndGetNextTag do
  begin
    if XML.CurrentTag = 'tr' then
    begin
      ImgIndex := -4;
      OK := False;
      Continue;
    end;

    if XML.CurrentTag = 'a' then
    begin
      try
      Filename := XML.GetAttribute('name');
      try
        Splitter := TStyleSplitter.Create(StringReplace(Filename, '_', ' ', [rfReplaceAll]), True);
        Chars := '';
        for s in Splitter.Values do
        if (Length(s) > 4) and not UCS4 then
        begin
          OK := false;
          Break;
        end
        else
        begin
          Chars := Chars + UCS4Chr(StrToInt('x' + s));
          OK := True;
        end;
      finally
        Splitter.Free;
      end;
      except
        OK := False;
      end;
      Continue;
    end;

    if XML.CurrentTag = 'td' then
    begin
      Inc(ImgIndex);
      Continue;
    end;

    if XML.CurrentTag = 'img' then
    begin
      if OK then
      if ImgIndex = TargetIndex then
      begin
        Base64 := XML.GetAttribute('src');
        ms1.Clear;
        ms2.Clear;
        ms1.WriteBuffer(Base64[23], Length(Base64) - 22);
        ms1.Position := 0;
        Base64DecodeStream(ms1, ms2);
        ms2.SaveToFile(OutPath + Filename + '.png');
        emoticons.Add(Filename + '.png = "' + Chars + '"');
      end;
      Continue;
    end;

    if XML.CurrentTag = '/table' then
    Break;
  end;
  emoticons.SaveToFile(OutPath + 'emoticons.txt', TEncoding.UTF8);
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  sl: TStringList;
begin
  sl := TStringList.Create;
  try
    sl.LoadFromFile('full-emoji-list.html');
    XML := TRedeemerXML.Create(sl.Text);
  finally
    sl.Free;
  end;
  while XML.GoToAndGetNextTag do
  if XML.CurrentTag = 'a' then
  if XML.GetAttribute('href') = '../format.html#col-vendor' then
  Break;
  repeat
    if XML.CurrentTag = 'a' then
    if XML.GetAttribute('href') = '../format.html#col-vendor' then
    ComboBox1.Items.Add(XML.GetInnerTextAndSkip);
    XML.GoToAndGetNextTag;
  until XML.CurrentTag = '/tr';

end;

end.
